#include <SoftwareSerial.h>
#include <Wire.h>
#include <OneWire.h>
#include <LiquidCrystal_I2C.h>
#include <BMP085.h>
BMP085  _bmp085 = BMP085();
long _bmp085P = 0;

SoftwareSerial Serial100(12, 11);

byte _d18x2x3Addr[8]={0x28, 0xFF, 0xC6, 0xE3, 0x71, 0x16, 0x3, 0xD7};//Датчик Аварии
byte _d18x2x2Addr[8]={0x28, 0xFF, 0x58, 0x4, 0x73, 0x16, 0x5, 0x9F};//Датчик Куба
byte _d18x2x1Addr[8]={0x28, 0xFF, 0x60, 0x2E, 0x73, 0x16, 0x5, 0x4E};//Датчик Колонны
LiquidCrystal_I2C _lcd1(0x27, 16, 2);//Адрес Дисплея

int _dispTempLength1=0;
boolean _isNeedClearDisp1;

struct UB_185384122
{
float ubo_120270494 = 0.00;
bool ubo_13416262 = 0;
float _gtv1 = 1.00;
float _gtv2 = 105.00;
};
UB_185384122 UB_185384122_Instance1;
UB_185384122 UB_185384122_Instance2;
UB_185384122 UB_185384122_Instance3;
float UB_185384122_ubi_117131038 = 0.00;
OneWire  _ow2(2);
int _AvlDFU0 = 0;
int _AvlDFU100 = 0;
bool _FreeLog3_IArr[2];
bool _FreeLog3_Q1_StArr[] = {0, 1};
bool _FreeLog1_IArr[3];
bool _FreeLog1_Q1_StArr[] = {1, 0, 0};
bool _FreeLog1_Q2_StArr[] = {1, 1, 0};
bool _FreeLog4_IArr[2];
bool _FreeLog4_Q1_StArr[] = {1, 1};
bool _FreeLog4_Q2_StArr[] = {0, 0};
int _PWDC = 0;
bool _gtv1 = 1;
float _gtv6 = 777;
float _gtv7 = 777;
int _gtv11 = 0;
bool _gtv12 = 0;
int _gtv2 = 0;
bool _gtv3 = 0;
bool _gtv4 = 0;
int _gtv8 = 110;
float _gtv9;
String _gtv13;
float _gtv14;
float _gtv15;
float _gtv17 = 760;
float _gtv18;
String _GSFS2 = "0";
int _FSFS4IO = 0;
bool _FSFS4CO = 0;
bool _D1B1 = 0;
bool _swi8;
bool _changeString2_ChOut = 0;
String _changeString2_OLV;
String _swi14;
unsigned long _d18x2x2Tti = 0UL;
float _d18x2x2O = 0.00;
String _GSFS5 = "0";
bool _gen4I = 0;
bool _gen4O = 0;
unsigned long _gen4P = 0UL;
String _swi11;
int _FSFS8IO = 0;
bool _gen7I = 0;
bool _gen7O = 0;
unsigned long _gen7P = 0UL;
unsigned long _d18x2x3Tti = 0UL;
float _d18x2x3O = 0.00;
bool _FreeLog1_Q1 = 0;
bool _FreeLog1_Q2 = 0;
bool _gen3I = 0;
bool _gen3O = 0;
unsigned long _gen3P = 0UL;
int _FSFS5IO = 0;
bool _tim1I = 0;
bool _tim1O = 0;
unsigned long _tim1P = 0UL;
unsigned long _stou1 = 0UL;
int _FSFS7IO = 0;
bool _FSFS7CO = 0;
String _GSFS10 = "0";
bool _swi9;
String _GSFS11 = "0";
bool _gen2I = 0;
bool _gen2O = 0;
unsigned long _gen2P = 0UL;
String _GSFS1 = "0";
bool _FreeLog4_Q1 = 0;
bool _FreeLog4_Q2 = 0;
String _swi7;
bool _gen5I = 0;
bool _gen5O = 0;
unsigned long _gen5P = 0UL;
String _GSFS3 = "0";
String _RVFU3Data;
bool _RVFU3Reset = 1;
bool _tim4I = 0;
bool _tim4O = 0;
unsigned long _tim4P = 0UL;
String _RVFU2Data;
bool _RVFU2Reset = 1;
unsigned long _d18x2x1Tti = 0UL;
float _d18x2x1O = 0.00;
bool _swi13;
bool _FreeLog3_Q1 = 0;
unsigned long _stou3 = 0UL;
bool _swi17;
bool _tim5I = 0;
bool _tim5O = 0;
unsigned long _tim5P = 0UL;
String _swi15;
bool _trgrt1 = 0;
bool _trgrt1I = 0;
int _FSFS6IO = 0;
bool _FSFS6CO = 0;
bool _gen8I = 0;
bool _gen8O = 0;
unsigned long _gen8P = 0UL;
int _disp5oldLength = 0;
bool _trgs3 = 0;
String _swi1;
unsigned long _bmp0852Tti = 0UL;
String _GSFS9 = "0";
bool _trgs1 = 0;
int _FSFS9IO = 0;
bool _FSFS9CO = 0;
int _disp2oldLength = 0;
int _FSFS3IO = 0;
bool _FSFS3CO = 0;
bool _tim3I = 0;
bool _tim3O = 0;
unsigned long _tim3P = 0UL;
String _swi4;
String _GSFS7 = "0";
String _GSFS4 = "0";
int _FSFS2IO = 0;
String _GSFS8 = "0";
bool _pzs1OES = 0;
String _swi16;
bool _swi3;
unsigned long _bmp0851Tti = 0UL;
bool _swi12;
bool _tim2I = 0;
bool _tim2O = 0;
unsigned long _tim2P = 0UL;
void setup()
{
Wire.begin();
delay(10);
TCCR2A = 0x00;
TCCR2B =  0x07;
TIMSK2=0x01;
TCNT2=100;
_bmp085.init();
Serial100.begin(9600);
Serial.begin(115200);
pinMode(9, INPUT);
digitalWrite(9, HIGH);
pinMode(7, OUTPUT);
pinMode(3, OUTPUT);
pinMode(5, OUTPUT);
pinMode(6, OUTPUT);
pinMode(8, OUTPUT);
pinMode(14, OUTPUT);
pinMode(15, OUTPUT);
pinMode(21, OUTPUT);

_lcd1.init();
_lcd1.noBacklight();
_stou3 = millis();
_stou1 = millis();
}
void loop()
{String _tempVariable_String;
if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}
_PWDC = 0;
if (_AvlDFU0){_AvlDFU0=0;} else{if (Serial.available()) {_AvlDFU0=1;  _readByteFromUART((Serial.read()),0);}}if (_AvlDFU100){_AvlDFU100=0;} else{if (Serial100.available()) {_AvlDFU100=1;  _readByteFromUART((Serial100.read()),100);}}if(_isTimer(_bmp0851Tti, 5000)) {
_bmp0851Tti = millis(); 
_bmp085.getPressure(&_bmp085P);
}

if (_gtv1){if(!_RVFU2Reset){_RVFU2Data = String(""); _RVFU2Reset =1;}} else {_RVFU2Reset =0;}
if (_gtv1){if(!_RVFU3Reset){_RVFU3Data = String(""); _RVFU3Reset =1;}} else {_RVFU3Reset =0;}
if(( (_AvlDFU100) || (_AvlDFU0) )) {_tim2O = 1; _tim2I = 1;} else { if(_tim2I) {_tim2I = 0; _tim2P = millis();} else { if (_tim2O) {if ( _isTimer(_tim2P, 5000)) _tim2O = 0;}}}
if (!(_tim2O)) { if (_trgrt1I) { _trgrt1 = 0;} else {_trgrt1 = 1; _trgrt1I = 1;} } else {_trgrt1 = 0; _trgrt1I = 0;}; 
 _gtv1 = _trgrt1;
if(_AvlDFU0) _trgs3 = 1;
if(_AvlDFU100) _trgs3 = 0;
if(_trgs3)
{_swi11=_RVFU2Data;}
else
{_swi11=_RVFU3Data;}
_gtv13 = _swi11;
_FSFS9IO = ((_gtv13).indexOf(String("#")));
_FSFS9CO = _FSFS9IO >-1 ;
_FSFS5IO = ((_gtv13).indexOf(String("!")));
_FSFS7IO = ((_gtv13).indexOf(String("$")));
_FSFS7CO = _FSFS7IO >-1 ;
_FSFS4IO = ((_gtv13).indexOf(String("&")));
_FSFS4CO = _FSFS4IO >-1 ;
_GSFS7 = (_gtv13).substring((_FSFS7IO), (_FSFS4IO));
_GSFS9 = (_GSFS7).substring(1);
if (_FSFS7CO) {
_gtv11 = (int((_stringToFloat(_GSFS9))));
}
_FSFS6IO = ((_gtv13).indexOf(String("*")));
_FSFS6CO = _FSFS6IO >-1 ;
if (_FSFS6CO) {
_gtv18 = (_bmp085P)/(133.3);
}
_FSFS8IO = ((_gtv13).indexOf(String("%")));
_GSFS4 = (_gtv13).substring((_FSFS6IO), (_FSFS8IO));
_GSFS8 = (_GSFS4).substring(1);
if (_FSFS6CO) {
_gtv7 = (_stringToFloat(_GSFS8));
}
_GSFS10 = (_gtv13).substring((_FSFS4IO), (_FSFS6IO));
_GSFS11 = (_GSFS10).substring(1);
if (_FSFS4CO) {
_gtv6 = (_stringToFloat(_GSFS11));
}
_FSFS3IO = ((_gtv13).indexOf(String("@")));
_FSFS3CO = _FSFS3IO >-1 ;
_FSFS2IO = ((_gtv13).indexOf(String("!")));
_GSFS3 = (_gtv13).substring((_FSFS3IO), (_FSFS2IO));
_GSFS5 = (_GSFS3).substring(1);
if (_FSFS3CO) {
_gtv8 = (int((_stringToFloat(_GSFS5))));
}
_GSFS1 = (_gtv13).substring((_FSFS9IO), (_FSFS5IO));
_GSFS2 = (_GSFS1).substring(1);
if (_FSFS9CO) {
_gtv2 = (int((_stringToFloat(_GSFS2))));
}

if(_isTimer(_d18x2x1Tti, 5000)) {
_d18x2x1Tti = millis(); 
_d18x2x1O=  _readDS18_ow2(_d18x2x1Addr, 0);}
UB_185384122_ubi_117131038 = (_d18x2x1O);
_func_UB_185384122(&UB_185384122_Instance1, UB_185384122_ubi_117131038);
if (UB_185384122_Instance1.ubo_13416262) {
_gtv9 = UB_185384122_Instance1.ubo_120270494;
}
if(_isTimer(_d18x2x2Tti, 5000)) {
_d18x2x2Tti = millis(); 
_d18x2x2O=  _readDS18_ow2(_d18x2x2Addr, 0);}
UB_185384122_ubi_117131038 = (_d18x2x2O);
_func_UB_185384122(&UB_185384122_Instance2, UB_185384122_ubi_117131038);
if (UB_185384122_Instance2.ubo_13416262) {
_gtv14 = UB_185384122_Instance2.ubo_120270494;
}
if(_isTimer(_d18x2x3Tti, 5000)) {
_d18x2x3Tti = millis(); 
_d18x2x3O=  _readDS18_ow2(_d18x2x3Addr, 0);}
UB_185384122_ubi_117131038 = (_d18x2x3O);
_func_UB_185384122(&UB_185384122_Instance3, UB_185384122_ubi_117131038);
if (UB_185384122_Instance3.ubo_13416262) {
_gtv15 = UB_185384122_Instance3.ubo_120270494;
}
_gtv17 = (_bmp085P)/(133.3);
if (1) {
_dispTempLength1 = ((((( _floatToStringWitRaz(_gtv9,1))) + (String(" ")) + (( _floatToStringWitRaz(_gtv17,1))) + (String(" ")) + (( _floatToStringWitRaz(_gtv14,1))) + (String(" "))))).length();
if (_disp5oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp5oldLength = _dispTempLength1;
_lcd1.setCursor(int((16 - _dispTempLength1)/2), 0);
_lcd1.print((((( _floatToStringWitRaz(_gtv9,1))) + (String(" ")) + (( _floatToStringWitRaz(_gtv17,1))) + (String(" ")) + (( _floatToStringWitRaz(_gtv14,1))) + (String(" ")))));
} else {
if (_disp5oldLength > 0) {_isNeedClearDisp1 = 1; _disp5oldLength = 0;} 
}
if(_gtv12)
{_swi7=String("1");}
else
{_swi7=String("0");}
digitalWrite(14, ( (!( (digitalRead (9)))) || ((_gtv15) > (65.00)) ));
if(( (!( (digitalRead (9)))) || ((_gtv15) > (65.00)) ))
{_swi4=String("1");}
else
{_swi4=String("0");}
if (!(_gtv1)){ if (_isTimer(_stou1, 2000 )) {Serial.print(((((String("HomeSamogon.ru")) + (String("/4.4")))) + (String(",")) + (( _floatToStringWitRaz(_gtv9,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv17,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv14,1))) + (String(",")) + ((String(_gtv11, DEC))) + (String(",")) + (_swi7) + (String(",")) + (( _floatToStringWitRaz(_gtv6,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv7,1))) + (String(",")) + ((String(_gtv2, DEC))) + (String(",")) + ((String(_gtv8, DEC))) + (String(",")) + (( _floatToStringWitRaz((((_stringToFloat(( _floatToStringWitRaz(_gtv14,1)))))+(3.14))*(((_stringToFloat(( _floatToStringWitRaz(_gtv9,1)))))+((_stringToFloat(( _floatToStringWitRaz(_gtv17,1)))))),1))) + (String(",")) + (( _floatToStringWitRaz(_gtv15,1))) + (String(",")) + (_swi4) + (String(",")) + (String("0")) + (String(",")) + (String("%")) + (String(",")))); _stou1 = millis();}} else {_stou1 = millis();}
if (!(_gtv1)){ if (_isTimer(_stou3, 2000 )) {Serial100.print(((((String("HomeSamogon.ru")) + (String("/4.4")))) + (String(",")) + (( _floatToStringWitRaz(_gtv9,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv17,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv14,1))) + (String(",")) + ((String(_gtv11, DEC))) + (String(",")) + (_swi7) + (String(",")) + (( _floatToStringWitRaz(_gtv6,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv7,1))) + (String(",")) + ((String(_gtv2, DEC))) + (String(",")) + ((String(_gtv8, DEC))) + (String(",")) + (( _floatToStringWitRaz((((_stringToFloat(( _floatToStringWitRaz(_gtv14,1)))))+(3.14))*(((_stringToFloat(( _floatToStringWitRaz(_gtv9,1)))))+((_stringToFloat(( _floatToStringWitRaz(_gtv17,1)))))),1))) + (String(",")) + (( _floatToStringWitRaz(_gtv15,1))) + (String(",")) + (_swi4) + (String(",")) + (String("0")) + (String(",")) + (String("%")) + (String(",")))); _stou3 = millis();}} else {_stou3 = millis();}

if((_gtv2) >= (2))
{_swi16=((( _floatToStringWitRaz((_gtv2)/(10.24),1))) + (String("% ")) + (String("Manual ")) + (( _floatToStringWitRaz(_gtv15,0))));}
else
{_swi16=String("HomeSamogon.ru");}
if(_gtv12)
{_swi14=String("START");}
else
{_swi14=String("STOP ");}
if((_gtv11) == (1))
{_swi15=((( _floatToStringWitRaz((_gtv2)/(10.24),1))) + (String("% ")) + (_swi14) + (String(" ")) + (( _floatToStringWitRaz(_gtv15,0))));}
else
{_swi15=_swi16;}
if (1) {
_dispTempLength1 = ((_swi15)).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(int((16 - _dispTempLength1)/2), 1);
_lcd1.print((_swi15));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}

_FreeLog3_IArr[0] = (_gtv2) < (50);
_FreeLog3_IArr[1] = (_gtv2) >= (972);
_FreeLog3_Q1 = _checkFreeLogicBlockOutput(_FreeLog3_IArr, 2, _FreeLog3_Q1_StArr, 2); 
if (!(( ((_gtv2) < (50)) || ((_gtv2) >= (972)) ))) {if (! _gen7I) { _gen7I = 1; _gen7O = 1; _gen7P =  millis(); } } else { _gen7I = 0 ;  _gen7O= 0;  } if (_gen7I ) { if (_gen7O) { if ( _isTimer( _gen7P , (map((_gtv2), (50), (972), (0), (8000))) )) { _gen7P = millis(); _gen7O = 0; } } else  { if ( _isTimer( _gen7P , (8000)-((map((_gtv2), (50), (972), (0), (8000)))) )) {  _gen7P = millis(); _gen7O = 1;  } } }
if(( ((_gtv2) < (50)) || ((_gtv2) >= (972)) ))
{_swi9=_FreeLog3_Q1;}
else
{_swi9=_gen7O;}
_gtv3 = _swi9;
_gtv4 = ( ((_gtv2) < (50)) || ((_gtv2) >= (972)) );

if(_gtv12)
{_swi1=String("1");}
else
{_swi1=String("0");}
_tempVariable_String = _swi1;
if (_changeString2_ChOut) {_changeString2_ChOut = 0;} else {if (!((_tempVariable_String.compareTo(_changeString2_OLV))==0)) {_changeString2_OLV = _tempVariable_String; _changeString2_ChOut = 1;}}
if (_changeString2_ChOut) {
_gtv2 = (map((_gtv2), (0), ((_gtv2)), (0), (((_gtv2)-((_gtv2)/(20))))));
}
if((_gtv9) >= ((_gtv7)-((_gtv7)-(_gtv6)))) _trgs1 = 1;
if((_gtv9) <= (_gtv7)) _trgs1 = 0;
if (_trgs1)
{ if (_tim5I) { if (_isTimer(_tim5P, 5000)) {_tim5O = 1;}} else {_tim5I =1; _tim5P = millis();}} else {_tim5O = 0; _tim5I = 0;}
_gtv12 = !(_tim5O);
if(_gtv4)
{_swi3=_gtv3;}
else
{_swi3=( (!(_tim5O)) && (_gtv3) );}
digitalWrite(8, !(_swi3));
digitalWrite(7, _swi3);

_FreeLog1_IArr[0] = (_gtv14) >= (_gtv8);
_FreeLog1_IArr[1] = (_gtv14) >= ((_gtv8)+(1));
_FreeLog1_IArr[2] = (_gtv8) == (110);
_FreeLog1_Q1 = _checkFreeLogicBlockOutput(_FreeLog1_IArr, 3, _FreeLog1_Q1_StArr, 3); 
_FreeLog1_Q2 = _checkFreeLogicBlockOutput(_FreeLog1_IArr, 3, _FreeLog1_Q2_StArr, 3); 
if (_FreeLog1_Q1)
{ if (_tim4I) { if (_isTimer(_tim4P, 5000)) {_tim4O = 1;}} else {_tim4I =1; _tim4P = millis();}} else {_tim4O = 0; _tim4I = 0;}
if (_tim4O) {if (! _gen2I) { _gen2I = 1; _gen2O = 1; _gen2P =  millis(); } } else { _gen2I = 0 ;  _gen2O= 0;  } if (_gen2I ) { if (_gen2O) { if ( _isTimer( _gen2P , 200 )) { _gen2P = millis(); _gen2O = 0; } } else  { if ( _isTimer( _gen2P , 400 )) {  _gen2P = millis(); _gen2O = 1;  } } }
if (_FreeLog1_Q2)
{ if (_tim3I) { if (_isTimer(_tim3P, 5000)) {_tim3O = 1;}} else {_tim3I =1; _tim3P = millis();}} else {_tim3O = 0; _tim3I = 0;}
if (_tim3O) {if (! _gen3I) { _gen3I = 1; _gen3O = 1; _gen3P =  millis(); } } else { _gen3I = 0 ;  _gen3O= 0;  } if (_gen3I ) { if (_gen3O) { if ( _isTimer( _gen3P , 300 )) { _gen3P = millis(); _gen3O = 0; } } else  { if ( _isTimer( _gen3P , 300 )) {  _gen3P = millis(); _gen3O = 1;  } } }
if (( ((_gtv15) > (65.00)) || (!( (digitalRead (9)))) ))
{ if (_tim1I) { if (_isTimer(_tim1P, 5000)) {_tim1O = 1;}} else {_tim1I =1; _tim1P = millis();}} else {_tim1O = 0; _tim1I = 0;}
if (_tim1O) {if (! _gen5I) { _gen5I = 1; _gen5O = 1; _gen5P =  millis(); } } else { _gen5I = 0 ;  _gen5O= 0;  } if (_gen5I ) { if (_gen5O) { if ( _isTimer( _gen5P , 100 )) { _gen5P = millis(); _gen5O = 0; } } else  { if ( _isTimer( _gen5P , 100 )) {  _gen5P = millis(); _gen5O = 1;  } } }
if(_gen5O)
{_swi8=_gen5O;}
else
{_swi8=( (_gen2O) || (_gen3O) );}
_FreeLog4_IArr[0] = _swi8;
_FreeLog4_IArr[1] = _swi8;
_FreeLog4_Q1 = _checkFreeLogicBlockOutput(_FreeLog4_IArr, 2, _FreeLog4_Q1_StArr, 2); 
_FreeLog4_Q2 = _checkFreeLogicBlockOutput(_FreeLog4_IArr, 2, _FreeLog4_Q2_StArr, 2); 
if(_FreeLog4_Q2) {if(! _D1B1){_lcd1.backlight(); _D1B1=1; }} else {if(_D1B1){_lcd1.noBacklight(); _D1B1=0; }}
if(_FreeLog4_Q1)
{if((!_pzs1OES)){ tone(4, 800); _pzs1OES =1;}} else {if(_pzs1OES){noTone(4); _pzs1OES =0;  }}
if (( (!(_gtv12)) && ((_gtv11) == (1)) )) {if (! _gen8I) { _gen8I = 1; _gen8O = 1; _gen8P =  millis(); } } else { _gen8I = 0 ;  _gen8O= 0;  } if (_gen8I ) { if (_gen8O) { if ( _isTimer( _gen8P , 1600 )) { _gen8P = millis(); _gen8O = 0; } } else  { if ( _isTimer( _gen8P , 400 )) {  _gen8P = millis(); _gen8O = 1;  } } }
if(_gtv4)
{_swi13=(_gtv2) < (50);}
else
{_swi13=_gen8O;}
digitalWrite(3, _swi13);
if (( (_gtv12) && ((_gtv11) == (1)) )) {if (! _gen4I) { _gen4I = 1; _gen4O = 1; _gen4P =  millis(); } } else { _gen4I = 0 ;  _gen4O= 0;  } if (_gen4I ) { if (_gen4O) { if ( _isTimer( _gen4P , 1600 )) { _gen4P = millis(); _gen4O = 0; } } else  { if ( _isTimer( _gen4P , 400 )) {  _gen4P = millis(); _gen4O = 1;  } } }
if(_gtv4)
{_swi12=(_gtv2) >= (972);}
else
{_swi12=_gen4O;}
digitalWrite(5, _swi12);
if(_gtv4)
{_swi17=0;}
else
{_swi17=(_gtv11) == (0);}
digitalWrite(6, _swi17);

digitalWrite(15, (_gtv14) >= (75));




}
float  _stringToFloat(String value)
  {
 
  return value.toFloat() ;
  }
String  _floatToStringWitRaz(float value, int raz)
{
 
  return String(value,raz);
}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }

ISR(TIMER2_OVF_vect)
{ TCNT2=100;
if(_PWDC >= 1000){asm volatile ("jmp 0x0000");}else{_PWDC = _PWDC+1;};
}
void _readByteFromUART(byte data,int port)
{
if (port==0){_RVFU2Data += char(data);}
if (port==100){_RVFU3Data += char(data);}
}
float _convertDS18x2xData(byte type_s, byte data[12])
{
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) 
  {
  raw = raw << 3; 
  if (data[7] == 0x10) { raw = (raw & 0xFFF0) + 12 - data[6]; }
  }
else 
  {
   byte cfg = (data[4] & 0x60);
   if (cfg == 0x00) raw = raw & ~7;   else if (cfg == 0x20) raw = raw & ~3;  else if (cfg == 0x40) raw = raw & ~1;
  }
return  (float)raw / 16.0;
}
float _readDS18_ow2(byte addr[8], byte type_s)
{  byte data[12];
byte i;
_ow2.reset();
_ow2.select(addr);
_ow2.write(0xBE);
for ( i = 0; i < 9; i++) {
 data[i] = _ow2.read();}
_ow2.reset();
_ow2.select(addr);
_ow2.write(0x44, 1);
return _convertDS18x2xData(type_s, data);}bool _checkFreeLogicBlockOutput(bool inArray[], int inArraySize, bool stArray[], int stArraySize)
{ int inIndex = 0;
  bool result = 1;
  for (int i = 0; i < stArraySize; i = i + 1)
  {
   if (!(inArray[inIndex] == stArray[i])) { result = 0;}
   inIndex ++;
   if (inIndex == inArraySize)
     {
     if (result) { return 1;} else {result = 1;}
     inIndex = 0;
     }
  }
  return 0;
}
void _func_UB_185384122(struct UB_185384122 *_ubInstans, float ubi_117131038)
{
float ubo_120270494 = _ubInstans->ubo_120270494;
bool ubo_13416262 = _ubInstans->ubo_13416262;
float _gtv1 = _ubInstans->_gtv1;
float _gtv2 = _ubInstans->_gtv2;
ubo_120270494 = ubi_117131038;
ubo_13416262 = ( ((_gtv1) < (ubi_117131038)) && ((ubi_117131038) < (_gtv2)) );
_ubInstans->ubo_120270494 = ubo_120270494;
_ubInstans->ubo_13416262 = ubo_13416262;
_ubInstans->_gtv1 = _gtv1;
_ubInstans->_gtv2 = _gtv2;

}
